package it.unibs.fp.patenteelibbrettopregoh;

import javax.xml.stream.*;
import java.io.*;
import java.util.ArrayList;

public class Parser {
    public static ArrayList<Persona> parsePersone(Formato formato, String fileName) {
        ArrayList<Persona> persone = new ArrayList<>();
        // Implement parsing logic here based on the format
        // For example, if formato is JSON, use a JSON library to parse the file
        // and populate the persone list.
        return persone;
    }

    public static Comuni parseComuni(Formato formato, String fileName) {
        Comuni comuni = new Comuni();
        if (formato == Formato.XML) {
            XMLInputFactory xmlif;
            XMLStreamReader xmlr;
            String currentElement = null;
            String nome = null;
            String codice = null;

            try (FileInputStream reader = new FileInputStream(fileName)) {
                xmlif = XMLInputFactory.newInstance();
                xmlr = xmlif.createXMLStreamReader(fileName, reader);

                while (xmlr.hasNext()) {
                    int event = xmlr.getEventType();

                    switch (event) {

                        case XMLStreamConstants.START_ELEMENT:
                            currentElement = xmlr.getLocalName(); // <- sposta qui, nel posto giusto
                            break;


                        case XMLStreamConstants.CHARACTERS:
                            String text = xmlr.getText().trim();
                            if (!text.isEmpty() && currentElement != null) {
                                if (currentElement.equals("nome")) {
                                    nome = text;
                                } else if (currentElement.equals("codice")) {
                                    codice = text;
                                }
                            }
                            break;

                        case XMLStreamConstants.END_ELEMENT:
                            String endTag = xmlr.getLocalName();
                            if (endTag.equals("comune")) {
                                Comune comune = new Comune(nome, codice);
                                comuni.addComune(comune);

                                nome = null;
                                codice = null;
                            }
                            currentElement = null; // reset solo alla fine di un elemento
                            break;
                    }

                    xmlr.next(); // importante: avanza solo una volta per ciclo
                }

                xmlr.close();
            } catch (FactoryConfigurationError | XMLStreamException | IOException e) {
                System.out.println("Error reading the file: " + e.getMessage());
            }

        } else if (formato == Formato.JSON) {
            // Implement XML parsing logic here
            // For example, use an XML library to read the file and populate the comuni list
        }
        return comuni;
    }
}
